<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInterfaceVehicleResult_V12 ArrayType
 * @subpackage Arrays
 */
class ArrayOfInterfaceVehicleResult_V12 extends AbstractStructArrayBase
{
    /**
     * The InterfaceVehicleResult_V12
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InterfaceVehicleResult_V12[]
     */
    public $InterfaceVehicleResult_V12;
    /**
     * Constructor method for ArrayOfInterfaceVehicleResult_V12
     * @uses ArrayOfInterfaceVehicleResult_V12::setInterfaceVehicleResult_V12()
     * @param \StructType\InterfaceVehicleResult_V12[] $interfaceVehicleResult_V12
     */
    public function __construct(array $interfaceVehicleResult_V12 = array())
    {
        $this
            ->setInterfaceVehicleResult_V12($interfaceVehicleResult_V12);
    }
    /**
     * Get InterfaceVehicleResult_V12 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InterfaceVehicleResult_V12[]|null
     */
    public function getInterfaceVehicleResult_V12()
    {
        return isset($this->InterfaceVehicleResult_V12) ? $this->InterfaceVehicleResult_V12 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInterfaceVehicleResult_V12 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterfaceVehicleResult_V12 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterfaceVehicleResult_V12ForArrayConstraintsFromSetInterfaceVehicleResult_V12(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInterfaceVehicleResult_V12InterfaceVehicleResult_V12Item) {
            // validation for constraint: itemType
            if (!$arrayOfInterfaceVehicleResult_V12InterfaceVehicleResult_V12Item instanceof \StructType\InterfaceVehicleResult_V12) {
                $invalidValues[] = is_object($arrayOfInterfaceVehicleResult_V12InterfaceVehicleResult_V12Item) ? get_class($arrayOfInterfaceVehicleResult_V12InterfaceVehicleResult_V12Item) : sprintf('%s(%s)', gettype($arrayOfInterfaceVehicleResult_V12InterfaceVehicleResult_V12Item), var_export($arrayOfInterfaceVehicleResult_V12InterfaceVehicleResult_V12Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InterfaceVehicleResult_V12 property can only contain items of type \StructType\InterfaceVehicleResult_V12, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InterfaceVehicleResult_V12 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InterfaceVehicleResult_V12[] $interfaceVehicleResult_V12
     * @return \ArrayType\ArrayOfInterfaceVehicleResult_V12
     */
    public function setInterfaceVehicleResult_V12(array $interfaceVehicleResult_V12 = array())
    {
        // validation for constraint: array
        if ('' !== ($interfaceVehicleResult_V12ArrayErrorMessage = self::validateInterfaceVehicleResult_V12ForArrayConstraintsFromSetInterfaceVehicleResult_V12($interfaceVehicleResult_V12))) {
            throw new \InvalidArgumentException($interfaceVehicleResult_V12ArrayErrorMessage, __LINE__);
        }
        if (is_null($interfaceVehicleResult_V12) || (is_array($interfaceVehicleResult_V12) && empty($interfaceVehicleResult_V12))) {
            unset($this->InterfaceVehicleResult_V12);
        } else {
            $this->InterfaceVehicleResult_V12 = $interfaceVehicleResult_V12;
        }
        return $this;
    }
    /**
     * Add item to InterfaceVehicleResult_V12 value
     * @throws \InvalidArgumentException
     * @param \StructType\InterfaceVehicleResult_V12 $item
     * @return \ArrayType\ArrayOfInterfaceVehicleResult_V12
     */
    public function addToInterfaceVehicleResult_V12(\StructType\InterfaceVehicleResult_V12 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterfaceVehicleResult_V12) {
            throw new \InvalidArgumentException(sprintf('The InterfaceVehicleResult_V12 property can only contain items of type \StructType\InterfaceVehicleResult_V12, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InterfaceVehicleResult_V12[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InterfaceVehicleResult_V12|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InterfaceVehicleResult_V12|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InterfaceVehicleResult_V12|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InterfaceVehicleResult_V12|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InterfaceVehicleResult_V12|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InterfaceVehicleResult_V12
     */
    public function getAttributeName()
    {
        return 'InterfaceVehicleResult_V12';
    }
}
